Index: XIOS/branchs/xios-2.5/arch/arch-GCC_LINUX.fcm
===================================================================
--- XIOS/branchs/xios-2.5/arch/arch-GCC_LINUX.fcm	(revision 1624)
+++ XIOS/branchs/xios-2.5/arch/arch-GCC_LINUX.fcm	(revision 1625)
@@ -12,5 +12,5 @@
 %DEBUG_CFLAGS   -g 
 
-%BASE_FFLAGS    -D__NONE__ -ffree-line-length-none 
+%BASE_FFLAGS    -D__NONE__ 
 %PROD_FFLAGS    -O3
 %DEV_FFLAGS     -g -O2
Index: XIOS/branchs/xios-2.5/src/generate_interface_impl.hpp
===================================================================
--- XIOS/branchs/xios-2.5/src/generate_interface_impl.hpp	(revision 1624)
+++ XIOS/branchs/xios-2.5/src/generate_interface_impl.hpp	(revision 1625)
@@ -215,5 +215,18 @@
     string fortranKindC=getStrFortranKindC<T>();
 
-    oss << "SUBROUTINE cxios_set_" << className << "_" << name << "(" << className << "_hdl, " << name << ") BIND(C)" << iendl;
+//    oss << "SUBROUTINE cxios_set_" << className << "_" << name << "(" << className << "_hdl, " << name << ") BIND(C)" << iendl;
+    int indent = oss.iword(iendl.index);
+    string str = "SUBROUTINE cxios_set_" + className + "_" + name + "(" + className + "_hdl, " + name + ") BIND(C)";
+    if ((str.length() + indent) >132)
+    {
+      oss << str.substr(0,130-indent) ;
+      oss << "&" << endl;
+      oss << "&" << str.substr(130-indent,str.length()) ;
+    }
+    else
+    {
+      oss << str;
+    }
+    oss << iendl;
     oss << "  USE ISO_C_BINDING" << iendl;
     oss << "  INTEGER (kind = C_INTPTR_T), VALUE :: " << className << "_hdl" << iendl;
@@ -231,5 +244,18 @@
   void CInterface::AttributeFortran2003Interface<string>(ostream& oss, const string& className, const string& name)
   {
-    oss << "SUBROUTINE cxios_set_" << className << "_" << name << "(" << className << "_hdl, " << name << ", " << name << "_size) BIND(C)" << iendl;
+//    oss << "SUBROUTINE cxios_set_" << className << "_" << name << "(" << className << "_hdl, " << name << ", " << name << "_size) BIND(C)" << iendl;
+    int indent = oss.iword(iendl.index);
+    string str ="SUBROUTINE cxios_set_" + className + "_" + name + "(" + className + "_hdl, " + name + ", " + name + "_size) BIND(C)";
+    if ((str.length() + indent) >132)
+    {
+      oss << str.substr(0,130-indent) ;
+      oss << "&" << endl;
+      oss << "&" << str.substr(130-indent,str.length()) ;
+    }
+    else
+    {
+      oss << str;
+    }
+    oss << iendl;
     oss << "  USE ISO_C_BINDING" << iendl;
     oss << "  INTEGER (kind = C_INTPTR_T), VALUE :: " << className << "_hdl" << iendl;
@@ -238,5 +264,17 @@
     oss << "END SUBROUTINE cxios_set_" << className << "_" << name << std::endl;
     oss << iendl;
-    oss << "SUBROUTINE cxios_get_" << className << "_" << name << "(" << className << "_hdl, " << name << ", " << name << "_size) BIND(C)" << iendl;
+//    oss << "SUBROUTINE cxios_get_" << className << "_" << name << "(" << className << "_hdl, " << name << ", " << name << "_size) BIND(C)" << iendl;
+    str = "SUBROUTINE cxios_get_" + className + "_" + name + "(" + className + "_hdl, " + name + ", " + name + "_size) BIND(C)";
+    if ((str.length() + indent) >132)
+    {
+      oss << str.substr(0,130-indent) ;
+      oss << "&" << endl;
+      oss << "&" << str.substr(130-indent,str.length()) ;
+    }
+    else
+    {
+      oss << str;
+    }
+    oss << iendl;
     oss << "  USE ISO_C_BINDING" << iendl;
     oss << "  INTEGER (kind = C_INTPTR_T), VALUE :: " << className << "_hdl" << iendl;
@@ -247,25 +285,20 @@
 
   template <>
-  void CInterface::AttributeFortran2003Interface<CDate>(ostream& oss, const string& className, const string& name)
-  {
-    oss << "SUBROUTINE cxios_set_" << className << "_" << name << "(" << className << "_hdl, " << name << ") BIND(C)" << iendl;
-    oss << "  USE ISO_C_BINDING" << iendl;
-    oss << "  USE IDATE" << iendl;
-    oss << "  INTEGER (kind = C_INTPTR_T), VALUE :: " << className << "_hdl" << iendl;
-    oss << "  TYPE(txios(date)), VALUE :: " << name << iendl;
-    oss << "END SUBROUTINE cxios_set_" << className << "_" << name << std::endl;
+  void CInterface::AttributeFortran2003Interface<CDuration>(ostream& oss, const string& className, const string& name)
+  {
+//    oss << "SUBROUTINE cxios_set_" << className << "_" << name << "(" << className << "_hdl, " << name << ") BIND(C)" << iendl;
+    string str = "SUBROUTINE cxios_set_" + className + "_" + name + "(" + className + "_hdl, " + name + ") BIND(C)";
+    int indent = oss.iword(iendl.index);
+    if ((str.length() + indent) >132)
+    {
+      oss << str.substr(0,130-indent) ;
+      oss << "&" << endl;
+      oss << "&" << str.substr(130-indent,str.length()) ;
+    }
+    else
+    {
+      oss << str;
+    }
     oss << iendl;
-    oss << "SUBROUTINE cxios_get_" << className << "_" << name << "(" << className << "_hdl, " << name << ") BIND(C)" << iendl;
-    oss << "  USE ISO_C_BINDING" << iendl;
-    oss << "  USE IDATE" << iendl;
-    oss << "  INTEGER (kind = C_INTPTR_T), VALUE :: " << className << "_hdl" << iendl;
-    oss << "  TYPE(txios(date)) :: " << name << iendl;
-    oss << "END SUBROUTINE cxios_get_" << className << "_" << name << std::endl;
-  }
-
-  template <>
-  void CInterface::AttributeFortran2003Interface<CDuration>(ostream& oss, const string& className, const string& name)
-  {
-    oss << "SUBROUTINE cxios_set_" << className << "_" << name << "(" << className << "_hdl, " << name << ") BIND(C)" << iendl;
     oss << "  USE ISO_C_BINDING" << iendl;
     oss << "  USE IDURATION" << iendl;
Index: XIOS/branchs/xios-2.5/src/interface/fortran_attr/interpolate_domain_interface_attr.F90
===================================================================
--- XIOS/branchs/xios-2.5/src/interface/fortran_attr/interpolate_domain_interface_attr.F90	(revision 1624)
+++ XIOS/branchs/xios-2.5/src/interface/fortran_attr/interpolate_domain_interface_attr.F90	(revision 1625)
@@ -88,5 +88,6 @@
 
 
-    SUBROUTINE cxios_set_interpolate_domain_read_write_convention(interpolate_domain_hdl, read_write_convention, read_write_convention_size) BIND(C)
+    SUBROUTINE cxios_set_interpolate_domain_read_write_convention(interpolate_domain_hdl, read_write_convention, read_write_conven&
+&tion_size) BIND(C)
       USE ISO_C_BINDING
       INTEGER (kind = C_INTPTR_T), VALUE :: interpolate_domain_hdl
@@ -95,5 +96,6 @@
     END SUBROUTINE cxios_set_interpolate_domain_read_write_convention
 
-    SUBROUTINE cxios_get_interpolate_domain_read_write_convention(interpolate_domain_hdl, read_write_convention, read_write_convention_size) BIND(C)
+    SUBROUTINE cxios_get_interpolate_domain_read_write_convention(interpolate_domain_hdl, read_write_convention, read_write_conven&
+&tion_size) BIND(C)
       USE ISO_C_BINDING
       INTEGER (kind = C_INTPTR_T), VALUE :: interpolate_domain_hdl