Index: XIOS/dev/dev_trunk_omp/src/calendar.cpp
===================================================================
--- XIOS/dev/dev_trunk_omp/src/calendar.cpp	(revision 1628)
+++ XIOS/dev/dev_trunk_omp/src/calendar.cpp	(revision 1629)
@@ -119,10 +119,10 @@
         this->timestep = timestep;
       }
-
+/*
       int CCalendar::getStep(void) const
       {
         return step;
       }
-
+*/
       const CDate& CCalendar::update(int step)
       {
@@ -153,8 +153,8 @@
       //-----------------------------------------------------------------
 
-      const CDuration& CCalendar::getTimeStep(void) const { return this->timestep; }
-      const CDate& CCalendar::getInitDate(void) const     { return this->initDate; }
-      const CDate& CCalendar::getTimeOrigin(void) const   { return this->timeOrigin; }
-      const CDate& CCalendar::getCurrentDate(void) const  { return this->currentDate; }
+      //const CDuration& CCalendar::getTimeStep(void) const { return this->timestep; }
+      //const CDate& CCalendar::getInitDate(void) const     { return this->initDate; }
+      //const CDate& CCalendar::getTimeOrigin(void) const   { return this->timeOrigin; }
+      //const CDate& CCalendar::getCurrentDate(void) const  { return this->currentDate; }
 
       //-----------------------------------------------------------------
@@ -169,5 +169,5 @@
       StdString CCalendar::getType(void) const { return StdString(this->getId()); }
 
-      int CCalendar::getYearTotalLength(const CDate& date) const { return (365 * 86400); }
+      //int CCalendar::getYearTotalLength(const CDate& date) const { return (365 * 86400); }
 
       //int CCalendar::getYearLength  (void) const { return 12; }
@@ -177,7 +177,7 @@
       //int CCalendar::getDayLengthInSeconds(void) const { return getDayLength() * getHourLength() * getMinuteLength(); }
 
-      bool CCalendar::hasLeapYear() const { return false; }
-
-      StdString CCalendar::getMonthName(int monthId) const
+      //bool CCalendar::hasLeapYear() const { return false; }
+
+      /*StdString CCalendar::getMonthName(int monthId) const
       {
         static const StdString MonthNames[] =
@@ -185,5 +185,5 @@
             "july",    "august",   "september", "october", "november", "december" };
         return MonthNames[monthId - 1];
-      }
+      }*/
 
       const StdString CCalendar::getMonthShortName(int monthId) const
Index: XIOS/dev/dev_trunk_omp/src/calendar.hpp
===================================================================
--- XIOS/dev/dev_trunk_omp/src/calendar.hpp	(revision 1628)
+++ XIOS/dev/dev_trunk_omp/src/calendar.hpp	(revision 1629)
@@ -52,5 +52,5 @@
 
             /// Mutateur ///
-            void setTimeStep(const CDuration& timestep);
+            void setTimeStep(const CDuration& timestep) ;
             void setInitDate(const CDate& initDate);
             void setTimeOrigin(const CDate& timeOrigin);
@@ -60,8 +60,8 @@
 
             /// Accesseurs ///
-            const CDuration& getTimeStep(void) const;
-            const CDate& getInitDate(void) const;
-            const CDate& getTimeOrigin(void) const;
-            const CDate& getCurrentDate(void) const;
+            const CDuration& getTimeStep(void) const { return this->timestep; };
+            const CDate& getInitDate(void) const { return this->initDate; };
+            const CDate& getTimeOrigin(void) const { return this->timeOrigin; };
+            const CDate& getCurrentDate(void) const { return this->currentDate; };
 
          public :
@@ -70,5 +70,5 @@
             virtual StdString getType(void) const;
 
-            int getStep(void) const;
+            int getStep(void) const {return step;};
 
             inline int getMonthLength(const CDate& date) const
@@ -78,19 +78,26 @@
             };
 
-            virtual int getYearTotalLength(const CDate& date) const; // Retourne la durÃ©e d'une annÃ©e en seconde.
+            //virtual int getYearTotalLength(const CDate& date) const; // Retourne la durÃ©e d'une annÃ©e en seconde.
+            inline virtual int getYearTotalLength(const CDate& date) const { return (365 * 86400); } ; // Retourne la durÃ©e d'une annÃ©e en seconde.
 
             //virtual int getYearLength  (void) const; // Retourne la durÃ©e d'une annÃ©e en mois.
-            inline int getYearLength (void) const { return 12; } ;
-            inline int getDayLength   (void) const { return 24; } ; // Retourne la durÃ©e d'un jour en heures.
-            inline int getHourLength  (void) const { return 60; } ; // Retourne la durÃ©e d'une heure en minute.
-            inline int getMinuteLength(void) const {return 60; } ; // Retourne la durÃ©e d'une minute en secondes.
+            inline virtual int getYearLength (void) const { return 12; } ;
+            inline virtual int getDayLength   (void) const { return 24; } ; // Retourne la durÃ©e d'un jour en heures.
+            inline virtual int getHourLength  (void) const { return 60; } ; // Retourne la durÃ©e d'une heure en minute.
+            inline virtual int getMinuteLength(void) const {return 60; } ; // Retourne la durÃ©e d'une minute en secondes.
             /*! Returns the day length expressed in seconds. */
-            inline int getDayLengthInSeconds(void) const { return 86400; } ;
+            inline virtual int getDayLengthInSeconds(void) const { return 86400; } ;
 
-            virtual StdString getMonthName(int monthId) const;
+            inline virtual StdString getMonthName(int monthId) const
+            {
+              static const StdString MonthNames[] =
+                         { "january", "february", "march",     "april" ,  "may",      "june",
+                           "july",    "august",   "september", "october", "november", "december" };
+              return MonthNames[monthId - 1];
+            };
             virtual const StdString getMonthShortName(int monthId) const;
 
             /*! Test if the calendar can have leap year. */
-            virtual bool hasLeapYear() const;
+            inline virtual bool hasLeapYear() const {return false;};
 
             void initializeDate(int yr, int mth, int d, int hr = 0, int min = 0, int sec = 0);
Index: XIOS/dev/dev_trunk_omp/src/calendar_util.cpp
===================================================================
--- XIOS/dev/dev_trunk_omp/src/calendar_util.cpp	(revision 1628)
+++ XIOS/dev/dev_trunk_omp/src/calendar_util.cpp	(revision 1629)
@@ -1,4 +1,3 @@
 #include "calendar_util.hpp"
-#include "calendar.hpp"
 
 namespace xios
Index: XIOS/dev/dev_trunk_omp/src/date/allleap.cpp
===================================================================
--- XIOS/dev/dev_trunk_omp/src/date/allleap.cpp	(revision 1628)
+++ XIOS/dev/dev_trunk_omp/src/date/allleap.cpp	(revision 1629)
@@ -32,8 +32,8 @@
 
       ///--------------------------------------------------------------
-
+/*
       int CAllLeapCalendar::getYearTotalLength(const CDate & date) const
       { return (366 * 86400); }
-
+*/
       int CAllLeapCalendar::getMonthLength(const CDate & date) const
       {
@@ -41,8 +41,8 @@
          return (CCalendar::getMonthLength(date));
       }
-
+/*
       StdString CAllLeapCalendar::getType(void) const
       { return (StdString("all_leap")); }
-
+*/
       ///--------------------------------------------------------------
 } // namespace xios
Index: XIOS/dev/dev_trunk_omp/src/date/allleap.hpp
===================================================================
--- XIOS/dev/dev_trunk_omp/src/date/allleap.hpp	(revision 1628)
+++ XIOS/dev/dev_trunk_omp/src/date/allleap.hpp	(revision 1629)
@@ -26,10 +26,10 @@
 
             /// Accesseurs ///
-            virtual int getYearTotalLength(const CDate & date) const;
+            inline virtual int getYearTotalLength(const CDate & date) const { return (366 * 86400); };
             virtual int getMonthLength(const CDate & date) const;
-            virtual StdString getType(void) const;
+            virtual StdString getType(void) const { return (StdString("all_leap")); };
 
             /// Destructeur ///
-            virtual ~CAllLeapCalendar(void);
+            virtual ~CAllLeapCalendar(void) ;
 
       }; // class CAllLeapCalendar
Index: XIOS/dev/dev_trunk_omp/src/date/d360.cpp
===================================================================
--- XIOS/dev/dev_trunk_omp/src/date/d360.cpp	(revision 1628)
+++ XIOS/dev/dev_trunk_omp/src/date/d360.cpp	(revision 1629)
@@ -33,12 +33,12 @@
       ///--------------------------------------------------------------
 
-      int CD360Calendar::getYearTotalLength(const CDate & date) const
-      { return (360 * 86400); }
+      //int CD360Calendar::getYearTotalLength(const CDate & date) const
+      //{ return (360 * 86400); }
 
-      int CD360Calendar::getMonthLength(const CDate & date) const
-      { return (30); }
+      //int CD360Calendar::getMonthLength(const CDate & date) const
+      //{ return (30); }
 
-      StdString CD360Calendar::getType(void) const
-      { return (StdString("360_day")); }
+      //StdString CD360Calendar::getType(void) const
+      //{ return (StdString("360_day")); }
 
       ///--------------------------------------------------------------
Index: XIOS/dev/dev_trunk_omp/src/date/d360.hpp
===================================================================
--- XIOS/dev/dev_trunk_omp/src/date/d360.hpp	(revision 1628)
+++ XIOS/dev/dev_trunk_omp/src/date/d360.hpp	(revision 1629)
@@ -26,7 +26,7 @@
 
             /// Accesseurs ///
-            virtual int getYearTotalLength(const CDate & date) const;
-            virtual int getMonthLength(const CDate & date) const;
-            virtual StdString getType(void) const;
+            inline virtual int getYearTotalLength(const CDate & date) const { return (360 * 86400); };
+            inline virtual int getMonthLength(const CDate & date) const { return 30; };
+            inline virtual StdString getType(void) const { return (StdString("360_day")); };
 
             /// Destructeur ///
Index: XIOS/dev/dev_trunk_omp/src/date/gregorian.cpp
===================================================================
--- XIOS/dev/dev_trunk_omp/src/date/gregorian.cpp	(revision 1628)
+++ XIOS/dev/dev_trunk_omp/src/date/gregorian.cpp	(revision 1629)
@@ -55,8 +55,8 @@
       }
 
-      StdString CGregorianCalendar::getType(void) const
-      { return (StdString("gregorian")); }
+      //StdString CGregorianCalendar::getType(void) const
+      //{ return (StdString("gregorian")); }
 
-      bool CGregorianCalendar::hasLeapYear() const { return true; }
+      //bool CGregorianCalendar::hasLeapYear() const { return true; }
 
       ///--------------------------------------------------------------
Index: XIOS/dev/dev_trunk_omp/src/date/gregorian.hpp
===================================================================
--- XIOS/dev/dev_trunk_omp/src/date/gregorian.hpp	(revision 1628)
+++ XIOS/dev/dev_trunk_omp/src/date/gregorian.hpp	(revision 1629)
@@ -28,7 +28,8 @@
             virtual int getYearTotalLength(const CDate & date) const;
             virtual int getMonthLength(const CDate & date) const;
-            virtual StdString getType(void) const;
+            inline virtual StdString getType(void) const { return (StdString("gregorian")); };
+            inline virtual int getYearLength (void) const { return 12; } ;
 
-            virtual bool hasLeapYear() const;
+            inline virtual bool hasLeapYear() const { return true; };
 
             /// Destructeur ///