Index: XIOS/dev/branch_openmp/src/io/netCdfInterface.cpp
===================================================================
--- XIOS/dev/branch_openmp/src/io/netCdfInterface.cpp	(revision 1555)
+++ XIOS/dev/branch_openmp/src/io/netCdfInterface.cpp	(revision 1642)
@@ -22,11 +22,5 @@
 int CNetCdfInterface::create(const StdString& fileName, int cMode, int& ncId)
 {
-  int status;
-  #pragma omp critical (_netcdf)
-  {
-    info(100)<<"start nc_create"<<std::endl;
-    status = nc_create(fileName.c_str(), cMode, &ncId);
-    info(100)<<"end nc_create"<<std::endl;
-  }
+  int status = nc_create(fileName.c_str(), cMode, &ncId);
   if (NC_NOERR != status)
   {
@@ -53,8 +47,11 @@
 \return Status code
 */
-int CNetCdfInterface::createPar(const StdString& fileName, int cMode, MPI_Comm comm, MPI_Info info, int& ncId)
-{
-  int status = xios::nc_create_par(fileName.c_str(), cMode, comm, to_mpi_info(MPI_INFO_NULL), &ncId);
-
+int CNetCdfInterface::createPar(const StdString& fileName, int cMode, ep_lib::MPI_Comm comm, ep_lib::MPI_Info info, int& ncId)
+{
+  #ifdef _usingMPI
+  int status = xios::nc_create_par(fileName.c_str(), cMode, comm, info, &ncId);
+  #elif _usingEP
+  int status = xios::nc_create_par(fileName.c_str(), cMode, to_mpi_comm(comm->mpi_comm), to_mpi_info(info), &ncId);
+  #endif
   if (NC_NOERR != status)
   {
@@ -81,11 +78,5 @@
 int CNetCdfInterface::open(const StdString& fileName, int oMode, int& ncId)
 {
-  int status;
-  #pragma omp critical (_netcdf)
-  {
-    info(100)<<"start nc_open"<<std::endl;
-    status = nc_open(fileName.c_str(), oMode, &ncId);
-    info(100)<<"end nc_open"<<std::endl;
-  }
+  int status = nc_open(fileName.c_str(), oMode, &ncId);
   if (NC_NOERR != status)
   {
@@ -113,8 +104,11 @@
 \return Status code
 */
-int CNetCdfInterface::openPar(const StdString& fileName, int oMode, MPI_Comm comm, MPI_Info info, int& ncId)
-{
-  int status = xios::nc_open_par(fileName.c_str(), oMode, comm, to_mpi_info(MPI_INFO_NULL), &ncId);
-  
+int CNetCdfInterface::openPar(const StdString& fileName, int oMode, ep_lib::MPI_Comm comm, ep_lib::MPI_Info info, int& ncId)
+{
+  #ifdef _usingMPI
+  int status = xios::nc_open_par(fileName.c_str(), oMode, comm, info, &ncId);
+  #elif _usingEP
+  int status = xios::nc_open_par(fileName.c_str(), oMode, to_mpi_comm(comm->mpi_comm), to_mpi_info(info), &ncId);
+  #endif
   if (NC_NOERR != status)
   {
@@ -139,12 +133,5 @@
 int CNetCdfInterface::close(int ncId)
 {
-  int status = NC_NOERR;
-  #pragma omp critical (_netcdf)
-  {
-    info(100)<<"start nc_close"<<std::endl;
-    status = nc_close(ncId);
-    info(100)<<"end nc_close"<<std::endl;
-  }
-      
+  int status = nc_close(ncId);
   if (NC_NOERR != status)
   {
@@ -168,12 +155,5 @@
 int CNetCdfInterface::reDef(int ncId)
 {
-  int status;
-  #pragma omp critical (_netcdf)
-  {
-    info(100)<<"start nc_reDef"<<std::endl;
-    status = nc_redef(ncId);
-    info(100)<<"end nc_reDef"<<std::endl;
-  }
-  
+  int status = nc_redef(ncId);
   if (NC_NOERR != status)
   {
@@ -197,11 +177,5 @@
 int CNetCdfInterface::endDef(int ncId)
 {
-  int status;
-  #pragma omp critical (_netcdf)
-  {
-    info(100)<<"start nc_enddef"<<std::endl;
-    status = nc_enddef(ncId);
-    info(100)<<"end nc_enddef"<<std::endl;
-  }
+  int status = nc_enddef(ncId);
   if (NC_NOERR != status)
   {
@@ -228,12 +202,5 @@
 int CNetCdfInterface::inqNcId(int ncid, const StdString& grpName, int& grpId)
 {
-  int status;
-  #pragma omp critical (_netcdf)
-  {
-    info(100)<<"start nc_inq_ncid"<<std::endl;
-    status = nc_inq_ncid(ncid, grpName.c_str(), &grpId);
-    info(100)<<"end nc_inq_ncid"<<std::endl;
-  }
-  
+  int status = nc_inq_ncid(ncid, grpName.c_str(), &grpId);
   if (NC_NOERR != status)
   {
@@ -261,11 +228,5 @@
 int CNetCdfInterface::inqVarId(int ncid, const StdString& varName, int& varId)
 {
-  int status;
-  #pragma omp critical (_netcdf)
-  {
-    info(100)<<"start nc_inq_varid"<<std::endl;
-    status = nc_inq_varid(ncid, varName.c_str(), &varId);
-    info(100)<<"end nc_inq_varid"<<std::endl;
-  }
+  int status = nc_inq_varid(ncid, varName.c_str(), &varId);
   if (NC_NOERR != status)
   {
@@ -292,12 +253,5 @@
 int CNetCdfInterface::inqDimId(int ncid, const StdString& dimName, int& dimId)
 {
-  int status;
-  #pragma omp critical (_netcdf)
-  {
-    info(100)<<"start nc_inq_dimid"<<std::endl;
-    status = nc_inq_dimid(ncid, dimName.c_str(), &dimId);
-    info(100)<<"end nc_inq_dimid"<<std::endl;
-  }
-  
+  int status = nc_inq_dimid(ncid, dimName.c_str(), &dimId);
   if (NC_NOERR != status)
   {
@@ -325,11 +279,5 @@
 {
   char varNameBuff[NC_MAX_NAME + 1];
-  int status;
-  #pragma omp critical (_netcdf)
-  {
-    info(100)<<"start nc_inq_varname"<<std::endl;
-    status = nc_inq_varname(ncid, varId, varNameBuff);
-    info(100)<<"end nc_inq_varname"<<std::endl;
-  }
+  int status = nc_inq_varname(ncid, varId, varNameBuff);
   if (NC_NOERR != status)
   {
@@ -355,11 +303,5 @@
 int CNetCdfInterface::inqUnLimDim(int ncid, int& dimId)
 {
-  int status;
-  #pragma omp critical (_netcdf)
-  {
-    info(100)<<"start nc_inq_unlimdim"<<std::endl;
-    status = nc_inq_unlimdim(ncid, &dimId);
-    info(100)<<"end nc_inq_unlimdim"<<std::endl;
-  }
+  int status = nc_inq_unlimdim(ncid, &dimId);
   if (NC_NOERR != status)
   {
@@ -387,11 +329,5 @@
 {
   char fullNameIn[NC_MAX_NAME + 1];
-  int status;
-  #pragma omp critical (_netcdf)
-  {
-    info(100)<<"start nc_inq_dimname"<<std::endl;
-    status = nc_inq_dimname(ncid, dimId, fullNameIn);
-    info(100)<<"end nc_inq_dimname"<<std::endl;
-  }
+  int status = nc_inq_dimname(ncid, dimId, fullNameIn);
   if (NC_NOERR != status)
   {
@@ -418,11 +354,5 @@
 int CNetCdfInterface::inqDimLen(int ncid, int dimId, StdSize& dimLen)
 {
-  int status;
-  #pragma omp critical (_netcdf)
-  {
-    info(100)<<"start nc_inq_dimlen"<<std::endl;
-    status = nc_inq_dimlen(ncid, dimId, &dimLen);
-    info(100)<<"end nc_inq_dimlen"<<std::endl;
-  }
+  int status = nc_inq_dimlen(ncid, dimId, &dimLen);
   if (NC_NOERR != status)
   {
@@ -449,11 +379,5 @@
 int CNetCdfInterface::inqVarNDims(int ncid, int varId, int& nDims)
 {
-  int status;
-  #pragma omp critical (_netcdf)
-  {
-    info(100)<<"start nc_inq_varndims"<<std::endl;
-    status = nc_inq_varndims(ncid, varId, &nDims);
-    info(100)<<"end nc_inq_varndims"<<std::endl;
-  }
+  int status = nc_inq_varndims(ncid, varId, &nDims);
   if (NC_NOERR != status)
   {
@@ -480,11 +404,5 @@
 int CNetCdfInterface::inqVarDimId(int ncid, int varId, int* dimIds)
 {
-  int status;
-  #pragma omp critical (_netcdf)
-  {
-    info(100)<<"start nc_inq_vardimid"<<std::endl;
-    status = nc_inq_vardimid(ncid, varId, dimIds);
-    info(100)<<"end nc_inq_vardimid"<<std::endl;
-  }
+  int status = nc_inq_vardimid(ncid, varId, dimIds);
   if (NC_NOERR != status)
   {
@@ -512,11 +430,5 @@
 int CNetCdfInterface::inqDimIds(int ncid, int& nDims, int* dimIds, int includeParents)
 {
-  int status;
-  #pragma omp critical (_netcdf)
-  {
-    info(100)<<"start nc_inq_dimids"<<std::endl;
-    status = nc_inq_dimids(ncid, &nDims, dimIds, includeParents);
-    info(100)<<"end nc_inq_dimids"<<std::endl;
-  }
+  int status = nc_inq_dimids(ncid, &nDims, dimIds, includeParents);
   if (NC_NOERR != status)
   {
@@ -545,18 +457,11 @@
   StdSize strlen = 0;
   std::vector<char> buff;
-  int status;
-  #pragma omp critical (_netcdf)
-  {
-    info(100)<<"start nc_inq_grpname_full"<<std::endl;
-    status = nc_inq_grpname_full(ncid, &strlen, NULL);
-    info(100)<<"end nc_inq_grpname_full"<<std::endl;
-  
-    if (NC_NOERR == status)
-    {
-      buff.resize(strlen + 1);
-      status = nc_inq_grpname_full(ncid, NULL, &buff[0]);
-    }
-    info(100)<<"start nc_inq_grpname_full"<<std::endl;
-  }
+  int status = nc_inq_grpname_full(ncid, &strlen, NULL);
+  if (NC_NOERR == status)
+  {
+    buff.resize(strlen + 1);
+    status = nc_inq_grpname_full(ncid, NULL, &buff[0]);
+  }
+
   if (NC_NOERR != status)
   {
@@ -585,11 +490,5 @@
 int CNetCdfInterface::inqGrpIds(int ncid, int& numgrps, int* ncids)
 {
-  int status;
-  #pragma omp critical (_netcdf)
-  {
-    info(100)<<"start nc_inq_grps"<<std::endl;
-    status = nc_inq_grps(ncid, &numgrps, ncids);
-    info(100)<<"end nc_inq_grps"<<std::endl;
-  }
+  int status = nc_inq_grps(ncid, &numgrps, ncids);
   if (NC_NOERR != status)
   {
@@ -616,11 +515,5 @@
 int CNetCdfInterface::inqVarIds(int ncid, int& nvars, int* varids)
 {
-  int status;
-  #pragma omp critical (_netcdf)
-  {
-    info(100)<<"start nc_inq_varids"<<std::endl;
-    status = nc_inq_varids(ncid, &nvars, varids);
-    info(100)<<"end nc_inq_varids"<<std::endl;
-  }
+  int status = nc_inq_varids(ncid, &nvars, varids);
   if (NC_NOERR != status)
   {
@@ -649,12 +542,5 @@
 int CNetCdfInterface::inqAtt(int ncid, int varid, const StdString& name, nc_type& type, size_t& len)
 {
-  int status;
-  #pragma omp critical (_netcdf)
-  {
-    info(100)<<"start nc_inq_att"<<std::endl;
-    status = nc_inq_att(ncid, varid, name.c_str(), &type, &len);
-    info(100)<<"end nc_inq_att"<<std::endl;
-  }
-  
+  int status = nc_inq_att(ncid, varid, name.c_str(), &type, &len);
   if (NC_NOERR != status)
   {
@@ -680,11 +566,5 @@
 int CNetCdfInterface::inqNAtts(int ncid, int& ngatts)
 {
-  int status;
-  #pragma omp critical (_netcdf)
-  {
-    info(100)<<"start nc_inq_natts"<<std::endl;
-    status = nc_inq_natts(ncid, &ngatts);
-    info(100)<<"end nc_inq_natts"<<std::endl;
-  }
+  int status = nc_inq_natts(ncid, &ngatts);
   if (NC_NOERR != status)
   {
@@ -711,11 +591,5 @@
 int CNetCdfInterface::inqVarNAtts(int ncid, int varid, int& natts)
 {
-  int status;
-  #pragma omp critical (_netcdf)
-  {
-    info(100)<<"start nc_inq_varnatts"<<std::endl;
-    status = nc_inq_varnatts(ncid, varid, &natts);
-    info(100)<<"end nc_inq_varnatts"<<std::endl;
-  }
+  int status = nc_inq_varnatts(ncid, varid, &natts);
   if (NC_NOERR != status)
   {
@@ -738,11 +612,5 @@
 {
   std::vector<char> attName(NC_MAX_NAME + 1,' ');
-  int status;
-  #pragma omp critical (_netcdf)
-  {
-    info(100)<<"start nc_inq_attname"<<std::endl;
-    status = nc_inq_attname(ncid, varid, attnum, &attName[0]);
-    info(100)<<"end nc_inq_attname"<<std::endl;
-  }
+  int status = nc_inq_attname(ncid, varid, attnum, &attName[0]);
   if (NC_NOERR != status)
   {
@@ -775,11 +643,5 @@
 int CNetCdfInterface::defGrp(int parentNcid, const StdString& grpName, int& grpId)
 {
-  int status;
-  #pragma omp critical (_netcdf)
-  {
-    info(100)<<"start nc_def_grp"<<std::endl;
-    status = nc_def_grp(parentNcid, grpName.c_str(), &grpId);
-    info(100)<<"end nc_def_grp"<<std::endl;
-  }
+  int status = nc_def_grp(parentNcid, grpName.c_str(), &grpId);
   if (NC_NOERR != status)
   {
@@ -806,11 +668,5 @@
 int CNetCdfInterface::defDim(int ncid, const StdString& dimName, StdSize dimLen, int& dimId)
 {
-  int status;
-  #pragma omp critical (_netcdf)
-  {
-    info(100)<<"start nc_def_dim"<<std::endl;
-    status = nc_def_dim(ncid, dimName.c_str(), dimLen, &dimId);
-    info(100)<<"end nc_def_dim"<<std::endl;
-  }
+  int status = nc_def_dim(ncid, dimName.c_str(), dimLen, &dimId);
   if (NC_NOERR != status)
   {
@@ -843,11 +699,5 @@
                              int nDims, const int dimIds[], int& varId)
 {
-  int status;
-  #pragma omp critical (_netcdf)
-  {
-    info(100)<<"start nc_def_var"<<std::endl;
-    status = nc_def_var(ncid, varName.c_str(), xtype, nDims, dimIds, &varId);
-    info(100)<<"end nc_def_var"<<std::endl;
-  }
+  int status = nc_def_var(ncid, varName.c_str(), xtype, nDims, dimIds, &varId);
   if (NC_NOERR != status)
   {
@@ -878,11 +728,5 @@
 int CNetCdfInterface::defVarChunking(int ncid, int varId, int storage, StdSize chunkSize[])
 {
-  int status;
-  #pragma omp critical (_netcdf)
-  {
-    info(100)<<"start nc_def_var_chunking"<<std::endl;
-    status = nc_def_var_chunking(ncid, varId, storage, chunkSize);
-    info(100)<<"end nc_def_var_chunking"<<std::endl;
-  }
+  int status = nc_def_var_chunking(ncid, varId, storage, chunkSize);
   if (NC_NOERR != status)
   {
@@ -912,11 +756,5 @@
   
   if (compressionLevel == 0) return NC_NOERR ;
-  int status;
-  #pragma omp critical (_netcdf)
-  {
-    info(100)<<"start nc_def_var_deflate"<<std::endl;
-    status = nc_def_var_deflate(ncid, varId, (compressionLevel > 0), (compressionLevel > 0), compressionLevel);
-    info(100)<<"end nc_def_var_deflate"<<std::endl;
-  }
+  int status = nc_def_var_deflate(ncid, varId, (compressionLevel > 0), (compressionLevel > 0), compressionLevel);
   if (NC_NOERR != status)
   {
@@ -944,11 +782,5 @@
 {
   int old_fill_mode;
-  int status;
-  #pragma omp critical (_netcdf)
-  {
-    info(100)<<"start nc_set_fill"<<std::endl;
-    status = nc_set_fill(ncid, fill ? NC_FILL: NC_NOFILL, &old_fill_mode);
-    info(100)<<"end nc_set_fill"<<std::endl;
-  }
+  int status = nc_set_fill(ncid, fill ? NC_FILL: NC_NOFILL, &old_fill_mode);
   if (NC_NOERR != status)
   {
@@ -977,11 +809,5 @@
 int CNetCdfInterface::defVarFill(int ncid, int varId, int noFill, void* fillValue)
 {
-  int status;
-  #pragma omp critical (_netcdf)
-  {
-    info(100)<<"start nc_def_var_fill"<<std::endl;
-    status = nc_def_var_fill(ncid, varId, noFill, fillValue);
-    info(100)<<"end nc_def_var_fill"<<std::endl;
-  }
+  int status = nc_def_var_fill(ncid, varId, noFill, fillValue);
   if (NC_NOERR != status)
   {
@@ -1011,11 +837,5 @@
 int CNetCdfInterface::varParAccess(int ncid, int varId, int access)
 {
-  int status;
-  #pragma omp critical (_netcdf)
-  {
-    info(100)<<"start nc_var_par_access"<<std::endl;
-    status = nc_var_par_access(ncid, varId, access);
-    info(100)<<"end nc_var_par_access"<<std::endl;
-  }
+  int status = nc_var_par_access(ncid, varId, access);
   if (NC_NOERR != status)
   {
@@ -1040,11 +860,5 @@
 int CNetCdfInterface::sync(int ncid)
 {
-  int status;
-  #pragma omp critical (_netcdf)
-  {
-    info(100)<<"start nc_sync"<<std::endl;
-    status = nc_sync(ncid);
-    info(100)<<"end nc_sync"<<std::endl;
-  }
+  int status = nc_sync(ncid);
   if (NC_NOERR != status)
   {
@@ -1066,12 +880,5 @@
 int CNetCdfInterface::ncGetAttType(int ncid, int varid, const char* attrName, double* data)
 {
-  int status;
-  #pragma omp critical (_netcdf)
-  {
-    info(100)<<"start nc_get_att_double"<<std::endl;
-    status = nc_get_att_double(ncid, varid, attrName, data);
-    info(100)<<"end nc_get_att_double"<<std::endl;
-  }
-  return status;
+  return nc_get_att_double(ncid, varid, attrName, data);
 }
 
@@ -1079,12 +886,5 @@
 int CNetCdfInterface::ncGetAttType(int ncid, int varid, const char* attrName, float* data)
 {
-  int status;
-  #pragma omp critical (_netcdf)
-  {
-    info(100)<<"start nc_get_att_float"<<std::endl;
-    status = nc_get_att_float(ncid, varid, attrName, data);
-    info(100)<<"end nc_get_att_float"<<std::endl;
-  }
-  return status;
+  return nc_get_att_float(ncid, varid, attrName, data);
 }
 
@@ -1092,12 +892,5 @@
 int CNetCdfInterface::ncGetAttType(int ncid, int varid, const char* attrName, int* data)
 {
-  int status;
-  #pragma omp critical (_netcdf)
-  {
-    info(100)<<"start nc_get_att_int"<<std::endl;
-    status = nc_get_att_int(ncid, varid, attrName, data);
-    info(100)<<"end nc_get_att_int"<<std::endl;
-  }
-  return status; 
+  return nc_get_att_int(ncid, varid, attrName, data);
 }
 
@@ -1105,12 +898,5 @@
 int CNetCdfInterface::ncGetAttType(int ncid, int varid, const char* attrName, long* data)
 {
-  int status;
-  #pragma omp critical (_netcdf)
-  {
-    info(100)<<"start nc_get_att_long"<<std::endl;
-    status = nc_get_att_long(ncid, varid, attrName, data);
-    info(100)<<"end nc_get_att_long"<<std::endl;
-  }
-  return status;
+  return nc_get_att_long(ncid, varid, attrName, data);
 }
 
@@ -1118,12 +904,5 @@
 int CNetCdfInterface::ncGetAttType(int ncid, int varid, const char* attrName, short* data)
 {
-  int status;
-  #pragma omp critical (_netcdf)
-  {
-    info(100)<<"start nc_get_att_short"<<std::endl;
-    status = nc_get_att_short(ncid, varid, attrName, data);
-    info(100)<<"end nc_get_att_short"<<std::endl;
-  }
-  return status;
+  return nc_get_att_short(ncid, varid, attrName, data);
 }
 
@@ -1131,12 +910,5 @@
 int CNetCdfInterface::ncGetAttType(int ncid, int varid, const char* attrName, char* data)
 {
-  int status;
-  #pragma omp critical (_netcdf)
-  {
-    info(100)<<"start nc_get_att_text"<<std::endl;
-    status = nc_get_att_text(ncid, varid, attrName, data);
-    info(100)<<"end nc_get_att_text"<<std::endl;
-  }
-  return status;
+  return nc_get_att_text(ncid, varid, attrName, data);
 }
 
@@ -1146,12 +918,5 @@
                                    StdSize numVal, const double* data)
 {
-  int status;
-  #pragma omp critical (_netcdf)
-  {
-    info(100)<<"start nc_put_att_double"<<std::endl;
-    status = nc_put_att_double(ncid, varid, attrName, NC_DOUBLE, numVal, data);
-    info(100)<<"end nc_put_att_double"<<std::endl;
-  }
-  return status;
+  return nc_put_att_double(ncid, varid, attrName, NC_DOUBLE, numVal, data);
 }
 
@@ -1160,12 +925,5 @@
                                    StdSize numVal, const float* data)
 {
-  int status;
-  #pragma omp critical (_netcdf)
-  {
-    info(100)<<"start nc_put_att_float"<<std::endl;
-    status = nc_put_att_float(ncid, varid, attrName, NC_FLOAT, numVal, data);
-    info(100)<<"end nc_put_att_float"<<std::endl;
-  }
-  return status;
+  return nc_put_att_float(ncid, varid, attrName, NC_FLOAT, numVal, data);
 }
 
@@ -1174,12 +932,5 @@
                                    StdSize numVal, const int* data)
 {
-  int status;
-  #pragma omp critical (_netcdf)
-  {
-    info(100)<<"start nc_put_att_int"<<std::endl;
-    status = nc_put_att_int(ncid, varid, attrName, NC_INT, numVal, data);
-    info(100)<<"end nc_put_att_int"<<std::endl;
-  }
-  return status;
+  return nc_put_att_int(ncid, varid, attrName, NC_INT, numVal, data);
 }
 
@@ -1188,12 +939,5 @@
                                    StdSize numVal, const long* data)
 {
-  int status;
-  #pragma omp critical (_netcdf)
-  {
-    info(100)<<"start nc_put_att_long"<<std::endl;
-    status = nc_put_att_long(ncid, varid, attrName, NC_LONG, numVal, data);
-    info(100)<<"end nc_put_att_long"<<std::endl;
-  }
-  return status;
+  return nc_put_att_long(ncid, varid, attrName, NC_LONG, numVal, data);
 }
 
@@ -1202,12 +946,5 @@
                                    StdSize numVal, const short* data)
 {
-  int status;
-  #pragma omp critical (_netcdf)
-  {
-    info(100)<<"start nc_put_att_short"<<std::endl;
-    status = nc_put_att_short(ncid, varid, attrName, NC_SHORT, numVal, data);
-    info(100)<<"end nc_put_att_short"<<std::endl;
-  }
-  return status;
+  return nc_put_att_short(ncid, varid, attrName, NC_SHORT, numVal, data);
 }
 
@@ -1216,12 +953,5 @@
                                    StdSize numVal, const char* data)
 {
-  int status;
-  #pragma omp critical (_netcdf)
-  {
-    info(100)<<"start nc_put_att_text"<<std::endl;
-    status = nc_put_att_text(ncid, varid, attrName, numVal, data);
-    info(100)<<"end nc_put_att_text"<<std::endl;
-  }
-  return status;
+  return nc_put_att_text(ncid, varid, attrName, numVal, data);
 }
 
@@ -1230,12 +960,5 @@
 int CNetCdfInterface::ncGetVaraType(int ncid, int varid, const StdSize* start, const StdSize* count, double* data)
 {
-  int status;
-  #pragma omp critical (_netcdf)
-  {
-    info(100)<<"start nc_get_vara_double"<<std::endl;
-    status = nc_get_vara_double(ncid, varid, start, count, data);
-    info(100)<<"end nc_get_vara_double"<<std::endl;
-  }
-  return status;
+  return nc_get_vara_double(ncid, varid, start, count, data);
 }
 
@@ -1243,12 +966,5 @@
 int CNetCdfInterface::ncGetVaraType(int ncid, int varid, const StdSize* start, const StdSize* count, float* data)
 {
-  int status;
-  #pragma omp critical (_netcdf)
-  {
-    info(100)<<"start nc_get_vara_float"<<std::endl;
-    status = nc_get_vara_float(ncid, varid, start, count, data);
-    info(100)<<"end nc_get_vara_float"<<std::endl;
-  }
-  return status; 
+  return nc_get_vara_float(ncid, varid, start, count, data);
 }
 
@@ -1256,12 +972,5 @@
 int CNetCdfInterface::ncGetVaraType(int ncid, int varid, const StdSize* start, const StdSize* count, int* data)
 {
-  int status;
-  #pragma omp critical (_netcdf)
-  {
-    info(100)<<"start nc_get_vara_int"<<std::endl;
-    status = nc_get_vara_int(ncid, varid, start, count, data);
-    info(100)<<"end nc_get_vara_int"<<std::endl;
-  }
-  return status; 
+  return nc_get_vara_int(ncid, varid, start, count, data);
 }
 
@@ -1269,12 +978,5 @@
 int CNetCdfInterface::ncGetVaraType(int ncid, int varid, const StdSize* start, const StdSize* count, char* data)
 {
-  int status;
-  #pragma omp critical (_netcdf)
-  {
-    info(100)<<"start nc_get_vara_text"<<std::endl;
-    status = nc_get_vara_text(ncid, varid, start, count, data);
-    info(100)<<"end nc_get_vara_text"<<std::endl;
-  }
-  return status;
+  return nc_get_vara_text(ncid, varid, start, count, data);
 }
 
@@ -1283,12 +985,5 @@
 int CNetCdfInterface::ncPutVaraType(int ncid, int varid, const StdSize* start, const StdSize* count, const double* data)
 {
-  int status;
-  #pragma omp critical (_netcdf)
-  {
-    info(100)<<"start nc_put_vara_double"<<std::endl;
-    status = nc_put_vara_double(ncid, varid, start, count, data);
-    info(100)<<"end nc_put_vara_double"<<std::endl;
-  }
-  return status;
+  return nc_put_vara_double(ncid, varid, start, count, data);
 }
 
@@ -1296,12 +991,5 @@
 int CNetCdfInterface::ncPutVaraType(int ncid, int varid, const StdSize* start, const StdSize* count, const float* data)
 {
-  int status;
-  #pragma omp critical (_netcdf)
-  {
-    info(100)<<"start nc_put_vara_float"<<std::endl;
-    status = nc_put_vara_float(ncid, varid, start, count, data);
-    info(100)<<"end nc_put_vara_float"<<std::endl;
-  }
-  return status;
+  return nc_put_vara_float(ncid, varid, start, count, data);
 }
 
@@ -1309,12 +997,5 @@
 int CNetCdfInterface::ncPutVaraType(int ncid, int varid, const StdSize* start, const StdSize* count, const int* data)
 {
-  int status;
-  #pragma omp critical (_netcdf)
-  {
-    info(100)<<"start nc_put_vara_int"<<std::endl;
-    status = nc_put_vara_int(ncid, varid, start, count, data);
-    info(100)<<"end nc_put_vara_int"<<std::endl;
-  }
-  return status;
+  return nc_put_vara_int(ncid, varid, start, count, data);
 }
 
@@ -1322,12 +1003,5 @@
 int CNetCdfInterface::ncPutVaraType(int ncid, int varid, const StdSize* start, const StdSize* count, const char* data)
 {
-  int status;
-  #pragma omp critical (_netcdf)
-  {
-    info(100)<<"start nc_put_vara_text"<<std::endl;
-    status = nc_put_vara_text(ncid, varid, start, count, data);
-    info(100)<<"end nc_put_vara_text"<<std::endl;
-  }
-  return status;
+  return nc_put_vara_text(ncid, varid, start, count, data);
 }
 
@@ -1342,12 +1016,5 @@
 {
    int varId = 0;
-   int status;
-   #pragma omp critical (_netcdf)
-   {
-     info(100)<<"start isVarExisted"<<std::endl;
-     status = nc_inq_varid(ncId, varName.c_str(), &varId);
-     info(100)<<"end isVarExisted"<<std::endl;
-   }
-   return (NC_NOERR == status);
+   return (NC_NOERR == (nc_inq_varid(ncId, varName.c_str(), &varId)));
 }
 
@@ -1355,12 +1022,5 @@
 {
    int dimId = 0;
-   int status;
-   #pragma omp critical (_netcdf)
-   {
-     info(100)<<"start isDimExisted"<<std::endl;
-     status = nc_inq_dimid(ncId, dimName.c_str(), &dimId);
-     info(100)<<"end isDimExisted"<<std::endl;
-   }
-   return (NC_NOERR == status);
+   return (NC_NOERR == (nc_inq_dimid(ncId, dimName.c_str(), &dimId)));
 }
 