Index: XIOS/dev/dev_trunk_omp/arch/arch-X64_IRENE_openmpi.env
===================================================================
--- XIOS/dev/dev_trunk_omp/arch/arch-X64_IRENE_openmpi.env	(revision 1650)
+++ XIOS/dev/dev_trunk_omp/arch/arch-X64_IRENE_openmpi.env	(revision 1650)
@@ -0,0 +1,14 @@
+module unload netcdf-c netcdf-fortran hdf5 flavor perl hdf5 boost blitz mpi gnu
+module load flavor/buildcompiler/intel/17 flavor/buildmpi/openmpi/2.0 flavor/hdf5/parallel
+module load flavor/openmpi/thread-multiple 
+module load mpi/openmpi/2.0.4
+module load netcdf-c/4.6.0
+module load flavor/hdf5/parallel
+module load netcdf-fortran/4.4.4
+module load hdf5/1.8.20
+module load boost
+module load blitz
+module load gnu
+#module load scalasca
+module load feature/bridge/heterogenous_mpmd
+
Index: XIOS/dev/dev_trunk_omp/arch/arch-X64_IRENE_openmpi.fcm
===================================================================
--- XIOS/dev/dev_trunk_omp/arch/arch-X64_IRENE_openmpi.fcm	(revision 1650)
+++ XIOS/dev/dev_trunk_omp/arch/arch-X64_IRENE_openmpi.fcm	(revision 1650)
@@ -0,0 +1,26 @@
+################################################################################
+###################                Projet XIOS               ###################
+################################################################################
+
+%CCOMPILER      mpicc -D_usingEP -qopenmp -D_openmpi
+%FCOMPILER      mpif90 -qopenmp
+%LINKER         mpif90 -qopenmp -nofor-main
+
+%BASE_CFLAGS    -g -O0 -std=c++11 -diag-disable 1125 -diag-disable 279
+%PROD_CFLAGS    -O3 -D BOOST_DISABLE_ASSERTS
+#%DEV_CFLAGS     -g -traceback
+%DEV_CFLAGS     -g 
+%DEBUG_CFLAGS   -DBZ_DEBUG -g -traceback -fno-inline
+
+%BASE_FFLAGS    -D__NONE__ 
+%PROD_FFLAGS    -O3
+#%DEV_FFLAGS     -g -traceback
+%DEV_FFLAGS     -g 
+%DEBUG_FFLAGS   -g -traceback
+
+%BASE_INC       -D__NONE__
+%BASE_LD        -lstdc++
+
+%CPP            mpicc -EP
+%FPP            cpp -P
+%MAKE           gmake
Index: XIOS/dev/dev_trunk_omp/arch/arch-X64_IRENE_openmpi.path
===================================================================
--- XIOS/dev/dev_trunk_omp/arch/arch-X64_IRENE_openmpi.path	(revision 1650)
+++ XIOS/dev/dev_trunk_omp/arch/arch-X64_IRENE_openmpi.path	(revision 1650)
@@ -0,0 +1,29 @@
+
+NETCDF_INCDIR="-I $NETCDFC_INCDIR -I $NETCDFFORTRAN_INCDIR"
+NETCDF_LIBDIR="-L $NETCDFC_LIBDIR -L $NETCDFFORTRAN_LIBDIR"
+NETCDF_LIB="-lnetcdf -lnetcdff"
+
+MPI_INCDIR=""
+MPI_LIBDIR=""
+MPI_LIB=""
+
+HDF5_INCDIR="-I$HDF5_INCDIR"
+HDF5_LIBDIR="-L$HDF5_LIBDIR"
+HDF5_LIB="-lhdf5_hl -lhdf5 -lz -lcurl"
+
+BOOST_INCDIR="-I $BOOST_INCDIR"
+BOOST_LIBDIR="-L $BOOST_LIBDIR"
+BOOST_LIB=""
+
+BLITZ_INCDIR="-I $BLITZ_INCDIR"
+BLITZ_LIBDIR="-L $BLITZ_LIBDIR"
+BLITZ_LIB=""
+
+OASIS_INCDIR="-I$PWD/../../oasis3-mct/BLD/build/lib/psmile.MPI1"
+OASIS_LIBDIR="-L$PWD/../../oasis3-mct/BLD/lib"
+OASIS_LIB="-lpsmile.MPI1 -lscrip -lmct -lmpeu"
+
+
+#only for MEMTRACK debuging : developper only
+ADDR2LINE_LIBDIR="-L${WORKDIR}/ADDR2LINE_LIB"
+ADDR2LINE_LIB="-laddr2line"
Index: XIOS/dev/dev_trunk_omp/arch/arch-X64_IRENE_trunk.env
===================================================================
--- XIOS/dev/dev_trunk_omp/arch/arch-X64_IRENE_trunk.env	(revision 1650)
+++ XIOS/dev/dev_trunk_omp/arch/arch-X64_IRENE_trunk.env	(revision 1650)
@@ -0,0 +1,13 @@
+module switch mpi mpi/intelmpi
+module unload netcdf-c netcdf-fortran hdf5 flavor perl hdf5 boost blitz mpi gnu
+module load gnu
+#module load mpi/openmpi/2.0.2
+#module load mpi/intelmpi/2017
+module load flavor/buildcompiler/intel/17
+module load flavor/buildmpi/intelmpi/2017
+module load flavor/hdf5/parallel
+module load netcdf-fortran/4.4.4
+module load hdf5/1.8.20
+module load boost
+module load blitz
+module load feature/bridge/heterogenous_mpmd
Index: XIOS/dev/dev_trunk_omp/arch/arch-X64_IRENE_trunk.fcm
===================================================================
--- XIOS/dev/dev_trunk_omp/arch/arch-X64_IRENE_trunk.fcm	(revision 1650)
+++ XIOS/dev/dev_trunk_omp/arch/arch-X64_IRENE_trunk.fcm	(revision 1650)
@@ -0,0 +1,29 @@
+################################################################################
+###################                Projet XIOS               ###################
+################################################################################
+#
+# Compile XIOS with intelmpi
+#
+
+%CCOMPILER      mpicc -qopenmp -D_usingMPI -D_intelmpi
+%FCOMPILER      mpif90 -qopenmp
+%LINKER         mpif90 -qopenmp -nofor-main
+
+%BASE_CFLAGS    -std=c++11 -diag-disable 1125 -diag-disable 279
+%PROD_CFLAGS    -O3 -D BOOST_DISABLE_ASSERTS
+#%DEV_CFLAGS     -g -traceback
+%DEV_CFLAGS     -g 
+%DEBUG_CFLAGS   -DBZ_DEBUG -g -traceback -fno-inline
+
+%BASE_FFLAGS    -D__NONE__ 
+%PROD_FFLAGS    -O3
+#%DEV_FFLAGS     -g -traceback
+%DEV_FFLAGS     -g 
+%DEBUG_FFLAGS   -g -traceback
+
+%BASE_INC       -D__NONE__
+%BASE_LD        -lstdc++
+
+%CPP            mpicc -EP
+%FPP            cpp -P
+%MAKE           gmake
Index: XIOS/dev/dev_trunk_omp/arch/arch-X64_IRENE_trunk.path
===================================================================
--- XIOS/dev/dev_trunk_omp/arch/arch-X64_IRENE_trunk.path	(revision 1650)
+++ XIOS/dev/dev_trunk_omp/arch/arch-X64_IRENE_trunk.path	(revision 1650)
@@ -0,0 +1,28 @@
+NETCDF_INCDIR="-I $NETCDFC_INCDIR -I $NETCDFFORTRAN_INCDIR"
+NETCDF_LIBDIR="-L $NETCDFC_LIBDIR -L $NETCDFFORTRAN_LIBDIR"
+NETCDF_LIB="-lnetcdf -lnetcdff"
+
+MPI_INCDIR=""
+MPI_LIBDIR=""
+MPI_LIB=""
+
+HDF5_INCDIR="-I$HDF5_INCDIR"
+HDF5_LIBDIR="-L$HDF5_LIBDIR"
+HDF5_LIB="-lhdf5_hl -lhdf5 -lz -lcurl"
+
+BOOST_INCDIR="-I $BOOST_INCDIR"
+BOOST_LIBDIR="-L $BOOST_LIBDIR"
+BOOST_LIB=""
+
+BLITZ_INCDIR="-I $BLITZ_INCDIR"
+BLITZ_LIBDIR="-L $BLITZ_LIBDIR"
+BLITZ_LIB=""
+
+OASIS_INCDIR="-I$PWD/../../oasis3-mct/BLD/build/lib/psmile.MPI1"
+OASIS_LIBDIR="-L$PWD/../../oasis3-mct/BLD/lib"
+OASIS_LIB="-lpsmile.MPI1 -lscrip -lmct -lmpeu"
+
+
+#only for MEMTRACK debuging : developper only
+ADDR2LINE_LIBDIR="-L${WORKDIR}/ADDR2LINE_LIB"
+ADDR2LINE_LIB="-laddr2line"
Index: XIOS/dev/dev_trunk_omp/extern/src_ep_dev/ep_type.hpp
===================================================================
--- XIOS/dev/dev_trunk_omp/extern/src_ep_dev/ep_type.hpp	(revision 1646)
+++ XIOS/dev/dev_trunk_omp/extern/src_ep_dev/ep_type.hpp	(revision 1650)
@@ -62,5 +62,5 @@
   };
 
-  class MPI_Fint
+  class EP_Fint
   {
     public:
@@ -68,6 +68,6 @@
     void* mpi_fint;
     
-    MPI_Fint() {}
-    MPI_Fint(void* fint);
+    EP_Fint() {}
+    EP_Fint(void* fint);
                                  
   };
Index: XIOS/dev/dev_trunk_omp/inputs/COMPLETE/context_atmosphere.xml
===================================================================
--- XIOS/dev/dev_trunk_omp/inputs/COMPLETE/context_atmosphere.xml	(revision 1646)
+++ XIOS/dev/dev_trunk_omp/inputs/COMPLETE/context_atmosphere.xml	(revision 1650)
@@ -3,5 +3,5 @@
 <context id="atmosphere">
 
-  <field_definition level="1" enabled=".FALSE." default_value="9.96921e+36">
+  <field_definition level="1" enabled=".TRUE." default_value="9.96921e+36">
     <field id="field_A_atm"  name="field_A_atm_origin" operation="average" freq_op="1ts" grid_ref="grid_A_atm" />
     <field id="field_A_atm_zoom"  name="field_A_atm" operation="average" freq_op="1ts" field_ref="field_A_atm" grid_ref="grid_A_atm_zoom" />
Index: XIOS/dev/dev_trunk_omp/inputs/REMAP/iodef.xml
===================================================================
--- XIOS/dev/dev_trunk_omp/inputs/REMAP/iodef.xml	(revision 1646)
+++ XIOS/dev/dev_trunk_omp/inputs/REMAP/iodef.xml	(revision 1650)
@@ -183,5 +183,5 @@
         <variable_group id="parameters" >
           <variable id="using_server" type="bool">true</variable>
-          <variable id="info_level" type="int">200</variable>
+          <variable id="info_level" type="int">0</variable>
           <variable id="print_file" type="bool">true</variable>
         </variable_group>
Index: XIOS/dev/dev_trunk_omp/src/interface/c/oasis_cinterface.cpp
===================================================================
--- XIOS/dev/dev_trunk_omp/src/interface/c/oasis_cinterface.cpp	(revision 1646)
+++ XIOS/dev/dev_trunk_omp/src/interface/c/oasis_cinterface.cpp	(revision 1650)
@@ -25,5 +25,5 @@
   void oasis_get_localcomm(MPI_Comm& comm)
   {
-    MPI_Fint f_comm ;
+    EP_Fint f_comm ;
     
     fxios_oasis_get_localcomm(&f_comm) ;
@@ -33,5 +33,5 @@
   void oasis_get_intracomm(MPI_Comm& comm_client_server,const std::string& server_id)
   {
-    MPI_Fint f_comm ;
+    EP_Fint f_comm ;
     
     fxios_oasis_get_intracomm(&f_comm,server_id.data(),server_id.size()) ;
@@ -41,5 +41,5 @@
   void oasis_get_intercomm(MPI_Comm& comm_client_server,const std::string& server_id)
   {
-    MPI_Fint f_comm ;
+    EP_Fint f_comm ;
     
     fxios_oasis_get_intercomm(&f_comm,server_id.data(),server_id.size()) ;
Index: XIOS/dev/dev_trunk_omp/src/interface/c/oasis_cinterface.hpp
===================================================================
--- XIOS/dev/dev_trunk_omp/src/interface/c/oasis_cinterface.hpp	(revision 1646)
+++ XIOS/dev/dev_trunk_omp/src/interface/c/oasis_cinterface.hpp	(revision 1650)
@@ -10,7 +10,7 @@
   void fxios_oasis_enddef(void) ;
   void fxios_oasis_finalize(void) ;
-  void fxios_oasis_get_localcomm(ep_lib::MPI_Fint* f_comm) ;
-  void fxios_oasis_get_intracomm(ep_lib::MPI_Fint* f_comm_client_server,const char* client_id,int str_len) ;
-  void fxios_oasis_get_intercomm(ep_lib::MPI_Fint* f_comm_client_server,const char* client_id,int str_len) ;
+  void fxios_oasis_get_localcomm(ep_lib::EP_Fint* f_comm) ;
+  void fxios_oasis_get_intracomm(ep_lib::EP_Fint* f_comm_client_server,const char* client_id,int str_len) ;
+  void fxios_oasis_get_intercomm(ep_lib::EP_Fint* f_comm_client_server,const char* client_id,int str_len) ;
 }
  
Index: XIOS/dev/dev_trunk_omp/src/mpi.hpp
===================================================================
--- XIOS/dev/dev_trunk_omp/src/mpi.hpp	(revision 1646)
+++ XIOS/dev/dev_trunk_omp/src/mpi.hpp	(revision 1650)
@@ -18,4 +18,5 @@
   #include <mpi.h>
   #define ep_lib 
+  #define EP_Fint MPI_Fint 
 #endif
 
Index: XIOS/dev/dev_trunk_omp/src/mpi_std.hpp
===================================================================
--- XIOS/dev/dev_trunk_omp/src/mpi_std.hpp	(revision 1646)
+++ XIOS/dev/dev_trunk_omp/src/mpi_std.hpp	(revision 1650)
@@ -20,4 +20,5 @@
 #include <mpi.h>
 #define ep_lib 
+#define EP_Fint MPI_Fint 
 #endif
 
Index: XIOS/dev/dev_trunk_omp/src/test/test_complete_omp.f90
===================================================================
--- XIOS/dev/dev_trunk_omp/src/test/test_complete_omp.f90	(revision 1646)
+++ XIOS/dev/dev_trunk_omp/src/test/test_complete_omp.f90	(revision 1650)
@@ -14,6 +14,6 @@
   TYPE(xios_duration)  :: dtime
   TYPE(xios_context) :: ctx_hdl
-  INTEGER,PARAMETER :: ni_glo=100
-  INTEGER,PARAMETER :: nj_glo=100
+  INTEGER,PARAMETER :: ni_glo=1000
+  INTEGER,PARAMETER :: nj_glo=1000
   INTEGER,PARAMETER :: llm=5
   DOUBLE PRECISION  :: lval(llm)=1
@@ -36,5 +36,5 @@
     if(provided .NE. 3) then
       print*, "provided thread level = ", provided
-      call MPI_Abort()
+      !call MPI_Abort()
     endif 
 
@@ -45,5 +45,5 @@
   CALL MPI_COMM_RANK(MPI_COMM_WORLD,rank,ierr)
   CALL MPI_COMM_SIZE(MPI_COMM_WORLD,size,ierr)
-  if(rank < size-2) then
+  if(rank < size-4) then
 
   !$omp parallel default(firstprivate) 
@@ -276,5 +276,5 @@
       CALL xios_send_field("field_A_srf",field_A_srf)
 
-      CALL wait_us(5000) ;
+      CALL wait_us(5) ;
 
 