Index: XIOS/dev/dev_trunk_omp/src/node/domain.cpp
===================================================================
--- XIOS/dev/dev_trunk_omp/src/node/domain.cpp	(revision 1646)
+++ XIOS/dev/dev_trunk_omp/src/node/domain.cpp	(revision 1661)
@@ -116,9 +116,9 @@
      \return the number of indexes written by each server
    */
-   int CDomain::getNumberWrittenIndexes(ep_lib::MPI_Comm writtenCom)
+   int CDomain::getNumberWrittenIndexes(MPI_Comm writtenCom)
    TRY
    {
      int writtenSize;
-     ep_lib::MPI_Comm_size(writtenCom, &writtenSize);
+     MPI_Comm_size(writtenCom, &writtenSize);
      return numberWrittenIndexes_[writtenSize];
    }
@@ -129,9 +129,9 @@
      \return the total number of indexes written by the servers
    */
-   int CDomain::getTotalNumberWrittenIndexes(ep_lib::MPI_Comm writtenCom)
+   int CDomain::getTotalNumberWrittenIndexes(MPI_Comm writtenCom)
    TRY
    {
      int writtenSize;
-     ep_lib::MPI_Comm_size(writtenCom, &writtenSize);
+     MPI_Comm_size(writtenCom, &writtenSize);
      return totalNumberWrittenIndexes_[writtenSize];
    }
@@ -142,18 +142,18 @@
      \return the offset of indexes written by each server
    */
-   int CDomain::getOffsetWrittenIndexes(ep_lib::MPI_Comm writtenCom)
+   int CDomain::getOffsetWrittenIndexes(MPI_Comm writtenCom)
    TRY
    {
      int writtenSize;
-     ep_lib::MPI_Comm_size(writtenCom, &writtenSize);
+     MPI_Comm_size(writtenCom, &writtenSize);
      return offsetWrittenIndexes_[writtenSize];
    }
    CATCH_DUMP_ATTR
 
-   CArray<int, 1>& CDomain::getCompressedIndexToWriteOnServer(ep_lib::MPI_Comm writtenCom)
+   CArray<int, 1>& CDomain::getCompressedIndexToWriteOnServer(MPI_Comm writtenCom)
    TRY
    {
      int writtenSize;
-     ep_lib::MPI_Comm_size(writtenCom, &writtenSize);
+     MPI_Comm_size(writtenCom, &writtenSize);
      return compressedIndexToWriteOnServer[writtenSize];
    }
@@ -707,14 +707,14 @@
      int v ;
      v=ibegin ;
-     ep_lib::MPI_Allgather(&v,1,MPI_INT,ibegin_g,1,MPI_INT,client->intraComm) ;
+     MPI_Allgather(&v,1,MPI_INT,ibegin_g,1,MPI_INT,client->intraComm) ;
      v=jbegin ;
-     ep_lib::MPI_Allgather(&v,1,MPI_INT,jbegin_g,1,MPI_INT,client->intraComm) ;
+     MPI_Allgather(&v,1,MPI_INT,jbegin_g,1,MPI_INT,client->intraComm) ;
      v=ni ;
-     ep_lib::MPI_Allgather(&v,1,MPI_INT,ni_g,1,MPI_INT,client->intraComm) ;
+     MPI_Allgather(&v,1,MPI_INT,ni_g,1,MPI_INT,client->intraComm) ;
      v=nj ;
-     ep_lib::MPI_Allgather(&v,1,MPI_INT,nj_g,1,MPI_INT,client->intraComm) ;
-
-     ep_lib::MPI_Allgatherv(lon.dataFirst(),ni,MPI_DOUBLE,lon_g.dataFirst(),ni_g, ibegin_g,MPI_DOUBLE,client->intraComm) ;
-     ep_lib::MPI_Allgatherv(lat.dataFirst(),nj,MPI_DOUBLE,lat_g.dataFirst(),nj_g, jbegin_g,MPI_DOUBLE,client->intraComm) ;
+     MPI_Allgather(&v,1,MPI_INT,nj_g,1,MPI_INT,client->intraComm) ;
+
+     MPI_Allgatherv(lon.dataFirst(),ni,MPI_DOUBLE,lon_g.dataFirst(),ni_g, ibegin_g,MPI_DOUBLE,client->intraComm) ;
+     MPI_Allgatherv(lat.dataFirst(),nj,MPI_DOUBLE,lat_g.dataFirst(),nj_g, jbegin_g,MPI_DOUBLE,client->intraComm) ;
 
       delete[] ibegin_g ;
@@ -1949,5 +1949,5 @@
           displs[0] = 0;
           int localCount = connectedServerRank_[nbServer].size() ;
-          ep_lib::MPI_Gather(&localCount, 1, MPI_INT, &counts[0], 1, MPI_INT, 0, client->intraComm) ;
+          MPI_Gather(&localCount, 1, MPI_INT, &counts[0], 1, MPI_INT, 0, client->intraComm) ;
           for (int i = 0; i < clientSize-1; ++i)
           {
@@ -1955,7 +1955,5 @@
           }
           std::vector<int> allConnectedServers(displs[clientSize-1]+counts[clientSize-1]);
-
-          ep_lib::MPI_Gatherv(&(connectedServerRank_[nbServer])[0], localCount, MPI_INT, &allConnectedServers[0], &counts[0], &displs[0], MPI_INT, 0, client->intraComm);
-
+          MPI_Gatherv(&(connectedServerRank_[nbServer])[0], localCount, MPI_INT, &allConnectedServers[0], &counts[0], &displs[0], MPI_INT, 0, client->intraComm);
 
           if ((allConnectedServers.size() != nbServer) && (rank == 0))
@@ -2022,9 +2020,9 @@
    CATCH_DUMP_ATTR
 
-  void CDomain::computeWrittenCompressedIndex(ep_lib::MPI_Comm writtenComm)
+  void CDomain::computeWrittenCompressedIndex(MPI_Comm writtenComm)
   TRY
   {
     int writtenCommSize;
-    ep_lib::MPI_Comm_size(writtenComm, &writtenCommSize);
+    MPI_Comm_size(writtenComm, &writtenCommSize);
     if (compressedIndexToWriteOnServer.find(writtenCommSize) != compressedIndexToWriteOnServer.end())
       return;
@@ -2083,6 +2081,6 @@
       {
              
-        ep_lib::MPI_Allreduce(&numberWrittenIndexes_[writtenCommSize], &totalNumberWrittenIndexes_[writtenCommSize], 1, MPI_INT, MPI_SUM, writtenComm);
-        ep_lib::MPI_Scan(&numberWrittenIndexes_[writtenCommSize], &offsetWrittenIndexes_[writtenCommSize], 1, MPI_INT, MPI_SUM, writtenComm);
+        MPI_Allreduce(&numberWrittenIndexes_[writtenCommSize], &totalNumberWrittenIndexes_[writtenCommSize], 1, MPI_INT, MPI_SUM, writtenComm);
+        MPI_Scan(&numberWrittenIndexes_[writtenCommSize], &offsetWrittenIndexes_[writtenCommSize], 1, MPI_INT, MPI_SUM, writtenComm);
         offsetWrittenIndexes_[writtenCommSize] -= numberWrittenIndexes_[writtenCommSize];
       }